/*
*   Byte-oriented AES-256 implementation.
*   All lookup tables replaced with 'on the fly' calculations.
*
*   Copyright (c) 2007 Ilya O. Levin, http://www.literatecode.com
*
*   Permission to use, copy, modify, and distribute this software for any
*   purpose with or without fee is hereby granted, provided that the above
*   copyright notice and this permission notice appear in all copies.
*
*   THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
*   WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
*   MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
*   ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
*   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
*   ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
*   OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
#include <stdio.h>
#include <stdlib.h>
#include "aes256.h"

static void dump(char* s, unsigned char i, unsigned char* buf, int sz)
{
    unsigned char a,b;
    printf(s);
    for (i = 0; i < (sz); i++)
    {
        if(0==(i%16))
            printf("\n");
        a = buf[i]/16;
        a += ((a<10)? '0' : 'A'-10);
        b = buf[i]%16;
        b += ((b<10)? '0' : 'A'-10);
        printf("%c%c", a,b);
    }
    printf("\n");
}

int main (int argc, char* argv[])
{
    unsigned int delay;

    aes256_context ctx;
    unsigned char key[32];
    unsigned char buf[16];
    unsigned char i;

    printf("%c\n",12);

    *(unsigned int*)0x276 = 0;

    /* put a test vector */
    for (i = 0; i < sizeof(buf); i++) buf[i] = i * 16 + i;
    for (i = 0; i < sizeof(key); i++) key[i] = i;

    dump("TXT:", i, buf, sizeof(buf));
    dump("KEY:", i, key, sizeof(key));
    printf("---\n");

    aes256_init(&ctx, key);
    aes256_encrypt_ecb(&ctx, buf);

    dump("ENC: ", i, buf, sizeof(buf));
    printf("TST:\n8EA2B7CA516745BFEAFC49904B496089\n");

    aes256_init(&ctx, key);
    aes256_decrypt_ecb(&ctx, buf);
    dump("DEC: ", i, buf, sizeof(buf));

    aes256_done(&ctx);
    printf("---\n");
    delay = 65536 - (*(unsigned int*)0x276);
    printf("TIME:  %d.%d [SEC]\n", delay / 100, delay % 100);

    return 0;
} /* main */
